#include <iostream.h>
#include <math.h>
#include <string.h>
#include <stdio.h>
#include "counter.h"
#include "Vsm.hpp"

extern "C" IDSIMMODEL __declspec(dllexport) * createdsimmodel (CHAR *device, ILICENCESERVER *ils)
{ 
	ils->authorize(0x88888888, 0x69);
	return new DSCOUNTER;
}

extern "C" VOID __declspec(dllexport) deletedsimmodel (IDSIMMODEL *model)
{
	delete (DSCOUNTER *)model;
}

INT DSCOUNTER::isdigital (CHAR *pinname)
{
	return 1;
}

VOID DSCOUNTER::setup (IINSTANCE *inst, IDSIMCKT *dsim)
{
	instance = inst;
	ckt = dsim;
	clock = instance->getdsimpin("CLOCK,clock", true);
	d0 = instance->getdsimpin("D0,d0", true);
	d1 = instance->getdsimpin("D1,d1", true);
	d2 = instance->getdsimpin("D2,d2", true);
	d3 = instance->getdsimpin("D3,d3", true);
	d4 = instance->getdsimpin("D4,d4", true);
	d5 = instance->getdsimpin("D5,d5", true);
	d6 = instance->getdsimpin("D6,d6", true);
	d7 = instance->getdsimpin("D7,d7", true);

	clock->setstate(FLT);
	d0->setstate(SLO);
	d1->setstate(SLO);
	d2->setstate(SLO);
	d3->setstate(SLO);
	d4->setstate(SLO);
	d5->setstate(SLO);
	d6->setstate(SLO);
	d7->setstate(SLO);
	data = 0;
}

VOID DSCOUNTER::runctrl (RUNMODES mode)
{
}

VOID DSCOUNTER::actuate (REALTIME time, ACTIVESTATE newstate)
{
	
}

BOOL DSCOUNTER::indicate (REALTIME time, ACTIVEDATA *data)
{	
	return FALSE;
}

VOID DSCOUNTER::simulate (ABSTIME time, DSIMMODES mode)
{	
	if (clock->isposedge()) {
		data++;
		if (data & 0x01)
			d0->setstate(time, 100, SHI);
		else
			d0->setstate(time, 100, SLO);
		if (data & 0x02)
			d1->setstate(time, 100, SHI);
		else
			d1->setstate(time, 100, SLO);
		if (data & 0x04)
			d2->setstate(time, 100, SHI);
		else
			d2->setstate(time, 100, SLO);
		if (data & 0x08)
			d3->setstate(time, 100, SHI);
		else
			d3->setstate(time, 100, SLO);
		if (data & 0x10)
			d4->setstate(time, 100, SHI);
		else
			d4->setstate(time, 100, SLO);
		if (data & 0x20)
			d5->setstate(time, 100, SHI);
		else
			d5->setstate(time, 100, SLO);
		if (data & 0x40)
			d6->setstate(time, 100, SHI);
		else
			d6->setstate(time, 100, SLO);
		if (data & 0x80)
			d7->setstate(time, 100, SHI);
		else
			d7->setstate(time, 100, SLO);
	}
}


VOID DSCOUNTER::callback (ABSTIME time, EVENTID eventid)
{
}
